#############################################################################
# Construction de la fenetre .topclauses
##############################################################################

# procedure to show window ShowWindow.topclauses
proc ShowWindow.topclauses { args } {
    # build widget .topclauses
    if {"[info procs XFEdit]" != ""} {
	catch "XFDestroy .topclauses"
    } {
	catch "destroy .topclauses"
    }
    toplevel .topclauses \
	-relief {raised}
    
    wm title .topclauses {daTac: Clauses}
    
    # bindings
    bind .topclauses <Enter> {
	focus .topclauses.fe.f2.e
	set i1 [.topclauses.fcl1.li.list curselection]
	set i2 [.topclauses.fcl2.li.list curselection]
	set i3 [.topclauses.fcl3.li.list curselection]
	if {$i1 == "" && $i2 == "" && $i3 == ""} {
	    ChangeButtonState .topclauses.f4.b disabled [list Erase Get Replace]
	}
	catch "unset i1"
	catch "unset i2"
	catch "unset i3"
    }

    global {font1}

    # build widget .topclauses.fcl1
    frame .topclauses.fcl1
    radiobutton .topclauses.fcl1.rb \
	-font $font1 \
	-bg {grey80} \
	-activebackground {grey80} \
	-activeforeground {grey10} \
	-text {Theory already treated} \
	-value {TheoryOK} \
	-variable {varSetClauses}

    frame .topclauses.fcl1.li
    ScrolledListbox2 .topclauses.fcl1.li -setgrid true -width 3 -height 3
    
    pack append .topclauses.fcl1 \
	.topclauses.fcl1.rb {top frame center fillx} \
	.topclauses.fcl1.li {top frame center expand fill}

    # bindings
    bind .topclauses.fcl1.li.list <B1-Motion> {%W selection anchor [%W nearest %y]}
    bind .topclauses.fcl1.li.list <Button-1> {%W selection anchor [%W nearest %y]}
    bind .topclauses.fcl1.li.list <ButtonRelease-1> {
	%W selection anchor [%W nearest %y]
	set l [list Erase Get Replace]
	set i [%W curselection]
	if {$i == ""} {
	    ChangeButtonState .topclauses.f4.b disabled $l
	} else {
	    ChangeButtonState .topclauses.f4.b normal $l
	}
	catch "unset i" ; catch "unset l"
    }
    
    # build widget .topclauses.fcl2
    frame .topclauses.fcl2
    radiobutton .topclauses.fcl2.rb \
	-font $font1 \
	-bg {grey80} \
	-activebackground {grey80} \
	-activeforeground {grey10} \
	-text {Theory} \
	-value {Theory} \
	-variable {varSetClauses}
    frame .topclauses.fcl2.li
    ScrolledListbox2 .topclauses.fcl2.li -setgrid true -width 3 -height 6

    pack append .topclauses.fcl2 \
	.topclauses.fcl2.rb {top frame center fillx} \
	.topclauses.fcl2.li {top frame center expand fill}

    # bindings
    bind .topclauses.fcl2.li.list <B1-Motion> {%W selection anchor [%W nearest %y]}
    bind .topclauses.fcl2.li.list <Button-1> {%W selection anchor [%W nearest %y]}
    bind .topclauses.fcl2.li.list <ButtonRelease-1> {
	%W selection anchor [%W nearest %y]
	set l [list Erase Get Replace]
	set i [%W curselection]
	if {$i == ""} {
	    ChangeButtonState .topclauses.f4.b disabled $l
	} else {
	    ChangeButtonState .topclauses.f4.b normal $l
	}
	catch "unset i" ; catch "unset l"
    }

    # build widget .topclauses.fcl3
    frame .topclauses.fcl3
    radiobutton .topclauses.fcl3.rb \
	-font $font1 \
	-bg {grey80} \
	-activebackground {grey80} \
	-activeforeground {grey10} \
	-text {Neg. of Conjecture} \
	-value {Conjecture} \
	-variable {varSetClauses}
    frame .topclauses.fcl3.li
    ScrolledListbox2 .topclauses.fcl3.li -setgrid true -width 3 -height 3

    pack append .topclauses.fcl3 \
	.topclauses.fcl3.rb {top frame center fillx} \
	.topclauses.fcl3.li {top frame center expand fill}

    # bindings
    bind .topclauses.fcl3.li.list <B1-Motion> {%W selection anchor [%W nearest %y]}
    bind .topclauses.fcl3.li.list <Button-1> {%W selection anchor [%W nearest %y]}
    bind .topclauses.fcl3.li.list <ButtonRelease-1> {
	%W selection anchor [%W nearest %y]
	set l [list Erase Get Replace]
	set i [%W curselection]
	if {$i == ""} {
	    ChangeButtonState .topclauses.f4.b disabled $l
	} else {
	    ChangeButtonState .topclauses.f4.b normal $l
	}
	catch "unset i" ; catch "unset l"
    }

    # build widget .topclauses.fe
    frame .topclauses.fe \
	-borderwidth {2} \
	-relief {raised}
    ScrolledEntry .topclauses.fe "New Clause:" entreeClause

    # bindings
    bind .topclauses.fe.f2.e <Key-Return> {
	.topclauses.f4.bAdd flash
	.topclauses.f4.bAdd invoke
    }
    
    # build widget .topclauses.f3
    frame .topclauses.f3 \
	-borderwidth {2} \
	-relief {raised}
    # build widget .topclauses.f3.bHelp
    button .topclauses.f3.bHelp \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    global entreeTopic
	    set entreeTopic "1. Clauses"
	    LoadHelp "2. Data Menu/1. Clauses.hlp"
	} \
	-cursor {question_arrow} \
	-text {Help}
    # build widget .topclauses.f3.bReset
    button .topclauses.f3.bReset \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    .topclauses.fcl1.li.list delete 0 end
	    .topclauses.fcl2.li.list delete 0 end
	    .topclauses.fcl3.li.list delete 0 end
	    set entreeClause ""
	    ChangeButtonState .topclauses.f4.b disabled [list Erase Get Replace]
	    ChangeButtonState .topclauses.f3.b active Store
	} \
	-cursor {pirate} \
	-text {Reset}
    # build widget .topclauses.f3.bCancel
    button .topclauses.f3.bCancel \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {DestroyWindow .topclauses} \
	-cursor {circle} \
	-text {Cancel}
    # build widget .topclauses.f3.bStore
    button .topclauses.f3.bStore \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    set listClausesTheoryOK [ListboxToVar .topclauses.fcl1.li.list]
	    set listClausesTheory [ListboxToVar .topclauses.fcl2.li.list]
	    set listClausesConjecture [ListboxToVar .topclauses.fcl3.li.list]
	    ChangeButtonState .topclauses.f3.b disabled Store
	} \
	-cursor {plus} \
	-state {disabled} \
	-text {Store}
    # build widget .topclauses.f3.bOk
    button .topclauses.f3.bOk \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    set listClausesTheoryOK [ListboxToVar .topclauses.fcl1.li.list]
	    set listClausesTheory [ListboxToVar .topclauses.fcl2.li.list]
	    set listClausesConjecture [ListboxToVar .topclauses.fcl3.li.list]
	    DestroyWindow .topclauses
	} \
	-cursor {hand1} \
	-text {Ok}
    
    # pack widget .topclauses.f3
    pack append .topclauses.f3 \
	.topclauses.f3.bHelp {left frame center expand fillx} \
	.topclauses.f3.bReset {left frame center expand fillx} \
	.topclauses.f3.bCancel {left frame center expand fillx} \
	.topclauses.f3.bStore {left frame center expand fillx} \
	.topclauses.f3.bOk {left frame center expand fillx}


    # build widget .topclauses.f4
    frame .topclauses.f4 \
	-borderwidth {2} \
	-relief {raised}
    
    # build widget .topclauses.f4.bAdd
    button .topclauses.f4.bAdd \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    set entreeClause [string trim $entreeClause]
	    if {$entreeClause != ""} {
		set clause [exec echo $entreeClause | $pathCheckClause]
		if {$clause == "Syntactical error!"} {
		    ShowWindow.topmessage
		    .topmessage.msg configure -text "\n\nImpossible to add the clause\n\n\"$entreeClause\"\n\n$clause\n\n"
		} elseif {$clause == "Lexicographical error!"} {
		    ShowWindow.topmessage
		    .topmessage.msg configure -text "\n\nImpossible to add the clause\n\n\"$entreeClause\"\n\n$clause\n\n"
		} else {
		    if {$varSetClauses == "TheoryOK"} {
			.topclauses.fcl1.li.list insert end $clause
		    } elseif {$varSetClauses == "Theory"} {
			.topclauses.fcl2.li.list insert end $clause
		    } else {
			.topclauses.fcl3.li.list insert end $clause
		    }
		    set entreeClause ""
		    ChangeButtonState .topclauses.f3.b active Store
		}
		catch "unset clause"
	    }
	} \
	-cursor {plus} \
	-text {Add}
    
    # build widget .topclauses.f4.bErase
    button .topclauses.f4.bErase \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    set i [.topclauses.fcl1.li.list curselection]
	    if {$i != ""} {
		.topclauses.fcl1.li.list delete $i
		ChangeButtonState .topclauses.f3.b active Store
	    } else {
		set i [.topclauses.fcl2.li.list curselection]
		if {$i != ""} {
		    .topclauses.fcl2.li.list delete $i
		    ChangeButtonState .topclauses.f3.b active Store
		} else {
		    set i [.topclauses.fcl3.li.list curselection]
		    if {$i != ""} {
			.topclauses.fcl3.li.list delete $i
			ChangeButtonState .topclauses.f3.b active Store
		    }
		}
	    }
	    catch "unset i"
	    ChangeButtonState .topclauses.f4.b disabled [list Erase Get Replace]
	} \
	-cursor {dot} \
	-state {disabled} \
	-text {Erase}
    
    # build widget .topclauses.f4.bGet
    button .topclauses.f4.bGet \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    set i [.topclauses.fcl1.li.list curselection]
	    if {$i != ""} {
		set entreeClause [.topclauses.fcl1.li.list get $i]
	    } else {
		set i [.topclauses.fcl2.li.list curselection]
		if {$i != ""} {
		    set entreeClause [.topclauses.fcl2.li.list get $i]
		} else {
		    set i [.topclauses.fcl3.li.list curselection]
		    if {$i != ""} {
			set entreeClause [.topclauses.fcl3.li.list get $i]
		    }
		}
	    }
	    catch "unset i"
	} \
	-cursor {bottom_side} \
	-state {disabled} \
	-text {Get}
    
    # build widget .topclauses.f4.bReplace
    button .topclauses.f4.bReplace \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    set entreeClause [string trim $entreeClause]
	    if {$entreeClause != ""} {
		set i1 [.topclauses.fcl1.li.list curselection]
		set i2 [.topclauses.fcl2.li.list curselection]
		set i3 [.topclauses.fcl3.li.list curselection]
		if {$i1 != "" || $i2 != "" || $i3 != ""} {
		    set clause [exec echo $entreeClause | $pathCheckClause]
		    if {$clause == "Syntactical error!"} {
			ShowWindow.topmessage
			.topmessage.msg configure -text "\n\nImpossible to replace by the clause\n\n\"$entreeClause\"\n\n$clause\n\n"
		    } elseif {$clause == "Lexicographical error!"} {
			ShowWindow.topmessage
			.topmessage.msg configure -text "\n\nImpossible to replace by the clause\n\n\"$entreeClause\"\n\n$clause\n\n"
		    } else {
			if {$i1 != ""} {
			    ModifyListbox .topclauses.fcl1.li.list $i1 $clause
			} elseif {$i2 != ""} {
			    ModifyListbox .topclauses.fcl2.li.list $i2 $clause
			} else {
			    ModifyListbox .topclauses.fcl3.li.list $i3 $clause
			}
			set entreeClause ""
			ChangeButtonState .topclauses.f4.b disabled [list Erase Get Replace]
			ChangeButtonState .topclauses.f3.b active Store
		    }
		    catch "unset clause"
		    catch "unset i1"
		    catch "unset i2"
		}
	    }
	} \
	-cursor {exchange} \
	-state {disabled} \
	-text {Replace}
    
    # pack widget .topclauses.f4
    pack append .topclauses.f4 \
	.topclauses.f4.bAdd {left frame center expand fill} \
	.topclauses.f4.bErase {left frame center expand fill} \
	.topclauses.f4.bGet {left frame center expand fill} \
	.topclauses.f4.bReplace {left frame center expand fill}

    # pack widget .topclauses
    pack append .topclauses \
	.topclauses.f4 {top frame center fillx} \
	.topclauses.fe {top frame center fillx} \
	.topclauses.f3 {bottom frame center fillx} \
	.topclauses.fcl1 {top frame center expand fill} \
	.topclauses.fcl2 {top frame center expand fill} \
	.topclauses.fcl3 {top frame center expand fill}

    wm geometry .topclauses 60x10

    global listClausesTheoryOK
    .topclauses.fcl1.li.list delete 0 end
    global listClausesTheory
    .topclauses.fcl2.li.list delete 0 end
    global listClausesConjecture
    .topclauses.fcl3.li.list delete 0 end
    VarToListbox $listClausesTheoryOK .topclauses.fcl1.li.list
    VarToListbox $listClausesTheory .topclauses.fcl2.li.list
    VarToListbox $listClausesConjecture .topclauses.fcl3.li.list
    global entreeClause
    set entreeClause ""
}
