##############################################################################
# Construction de la fenetre .topcombdedrules
##############################################################################

# procedure to show window ShowWindow.topcombdedrules
proc ShowWindow.topcombdedrules { args} {
    # xf ignore me 7
    
    # build widget .topcombdedrules
    if {"[info procs XFEdit]" != ""} {
	catch "XFDestroy .topcombdedrules"
    } {
	catch "destroy .topcombdedrules"
    }
    toplevel .topcombdedrules     -relief {raised}
    
    # Window manager configurations
    wm positionfrom .topcombdedrules program
    wm sizefrom .topcombdedrules program
#    wm geometry .topcombdedrules 450x200
    wm minsize .topcombdedrules 10 10
    wm title .topcombdedrules {daTac: Strategy of Deductions}

    global font1
    
    # bindings
    bind .topcombdedrules <Enter> {focus .topcombdedrules.fe.f2.e}
    
    # build widget .topcombdedrules.fb
    frame .topcombdedrules.fb \
	-borderwidth {2} \
	-relief {raised}
    
    # build widget .topcombdedrules.fb.bHelp
    button .topcombdedrules.fb.bHelp \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    global entreeTopic
	    set entreeTopic "6. Combination of Deductions"
	    LoadHelp "3. Parameters Menu/6. Combination of Deductions.hlp"
	} \
	-cursor {question_arrow} \
	-text {Help}

    # build widget .topcombdedrules.fb.bReset
    button .topcombdedrules.fb.bReset \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    global defaultCombDedRules
	    set entreeCombDedRules $defaultCombDedRules
	} \
	-cursor {pirate} \
	-text {Reset}
    
    # build widget .topcombdedrules.fb.bCancel
    button .topcombdedrules.fb.bCancel \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {DestroyWindow .topcombdedrules} \
	-cursor {circle} \
	-text {Cancel}
    
    # build widget .topcombdedrules.fb.bOk
    button .topcombdedrules.fb.bOk \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    set entreeCombDedRules [string trim $entreeCombDedRules]
	    set res [exec echo $entreeCombDedRules | $pathCheckStrat]
	    if {$res == "Syntactical error!"} {
		ShowWindow.topmessage
		.topmessage.msg configure -text "\n\nSyntactical error in the strategy:\n\n\t \"$entreeCombDedRules\"\n"
	    } elseif {$res == "Lexicographical error!"} {
		ShowWindow.topmessage
		.topmessage.msg configure -text "\n\nLexicographical error in the strategy:\n\n\t \"$entreeCombDedRules\"\n"
	    } else {
		set combDedRules $entreeCombDedRules
		DestroyWindow .topcombdedrules
	    }
	} \
	-cursor {hand1} \
	-text {Ok}
    
    # pack widget .topcombdedrules.fb
    pack append .topcombdedrules.fb \
	.topcombdedrules.fb.bHelp {left frame center expand fillx} \
	.topcombdedrules.fb.bReset {left frame center expand fillx} \
	.topcombdedrules.fb.bCancel {left frame center expand fillx} \
	.topcombdedrules.fb.bOk {left frame center expand fillx}

    # build widget .topcombdedrules.fe
    frame .topcombdedrules.fe \
	-borderwidth {2} \
	-relief {raised}
    ScrolledEntry .topcombdedrules.fe "Strategy:" entreeCombDedRules

    # bindings
    bind .topcombdedrules.fe.f2.e <Key-Return> {
	.topcombdedrules.fb.bOk flash
	.topcombdedrules.fb.bOk invoke
    }
    
    # build widget .topexecautomatic$i.ftext.text
    text .topcombdedrules.text \
	-borderwidth {2} \
	-relief {raised} \
	-font $font1 \
	-wrap word \
 	-padx {20} \
 	-pady {20} \
	-height {14}

    .topcombdedrules.text tag add tag1 1.0 1.end
    .topcombdedrules.text tag bind tag1 -relief sunken

    .topcombdedrules.text insert end "Compose your own strategy for combining deduction steps.\n\n"
    .topcombdedrules.text insert end "In this purpose, you can use:\n\n\n"
    .topcombdedrules.text insert end "Inference rules:   rp, lp, crp, clp, ep, ref, ef, res, f\n\n"
    .topcombdedrules.text insert end "      Operators:   \",\": or     \";\": and     \"+\": then\n\n"
    .topcombdedrules.text insert end "                   \"(...)n\": iteration (n: integer or *)\n\n"
    .topcombdedrules.text insert end "Example:   ref,(rcp;ep;(rp)*),(ep+(lp,clp))5\n\n"
    .topcombdedrules.text insert end "Default is:   rp,lp,crp,clp,ep,ref,ef,res,f"
    
    .topcombdedrules.text configure -state disabled

    # pack widget .topcombdedrules
    pack append .topcombdedrules \
	.topcombdedrules.fb {bottom frame center fill} \
	.topcombdedrules.fe {bottom frame center expand fillx} \
	.topcombdedrules.text {top frame center expand fill}
    
    if {"[info procs XFEdit]" != ""} {
	catch "XFMiscBindWidgetTree .topcombdedrules"
	after 2 "catch {XFEditSetShowWindows}"
    }
}
