##############################################################################
# Construction de la fenetre .topeditfile
##############################################################################

# procedure to show window ShowWindow.topeditfile
proc ShowWindow.topeditfile {} {
    # xf ignore me 7
    
    # build widget .topeditfile
    if {"[info procs XFEdit]" != ""} {
	catch "XFDestroy .topeditfile"
    } {
	catch "destroy .topeditfile"
    }
    toplevel .topeditfile 
    
    # Window manager configurations
    wm positionfrom .topeditfile ""
    wm sizefrom .topeditfile ""
    wm minsize .topeditfile 10 10
    wm title .topeditfile {File: Edit}
    
    global {font1}

    # bindings
    bind .topeditfile <Enter> {focus .topeditfile.fePath.f2.e}
    
    # build widget .topeditfile.bCancel
    button .topeditfile.bCancel \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {DestroyWindow .topeditfile} \
	-cursor {circle} \
	-text {Cancel}
    
    # build widget .topeditfile.bOk
    button .topeditfile.bOk \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    global entreeEditFile ; global entreeEditPath
	    if {$entreeEditFile != "" && $entreeEditPath != ""} {
		set entreeEditPath [AddSlash $entreeEditPath]
		
		# Verifier que le fichier $entreeEditFile existe
		.topeditfile.bOk configure -state disabled
		if {[file exists $entreeEditPath$entreeEditFile] == 0} {
		    ShowWindow.topmessage
		    .topmessage.msg configure -text "\n\nFile: Edit\n\nCan't find file\n\n\"$entreeEditPath$entreeEditFile\".\n\nNo such file or directory.\n\n"
		} else {
		    # Editer le fichier $entreeEditFile
		    global env
		    exec $env(daTac_EDITOR) $entreeEditPath$entreeEditFile &
		    .topeditfile.bCancel configure -state disabled
		    DestroyWindow .topeditfile
		}
	    }
	} \
	-cursor {hand1} \
	-state {disabled} \
	-text {Ok}
    
    # build widget .topeditfile.feFile
    frame .topeditfile.feFile \
	-borderwidth {2} \
	-relief {raised}
    
    ScrolledEntry .topeditfile.feFile {Filename:} entreeEditFile
    .topeditfile.feFile.f2.e configure -state {disabled}
    
    # build widget .topeditfile.fePath
    frame .topeditfile.fePath \
	-borderwidth {2} \
	-relief {raised}
    
    ScrolledEntry .topeditfile.fePath {Pathname:} entreeEditPath -width {30}

    # bindings
    bind .topeditfile.fePath.f2.e <Key-Return> {
	global entreeEditPath ; global entreeEditFile
	global varEditPath
	set entreeEditFile ""
	set entreeEditPath [string trim $entreeEditPath]
	if {$entreeEditPath == ""} {
	    set entreeEditPath $varEditPath
	} else {
	    set entreeEditPath [SearchDirectory [AddSlash $entreeEditPath]]
	    if {$entreeEditPath == ""} {
		set entreeEditPath $varEditPath
	    } else {
		set varEditPath $entreeEditPath
	    }
	}
	LsToListbox  $entreeEditPath "*" .topeditfile.flb.list
	.topeditfile.fePath.f2.e xview [expr [string length $entreeEditPath]-28]
    }
    
    # build widget .topeditfile.flb
    frame .topeditfile.flb
    
    ScrolledListbox2 .topeditfile.flb

    # bindings
    bind .topeditfile.flb.list <B1-Motion> {%W selection anchor [%W nearest %y]}
    bind .topeditfile.flb.list <Button-1> {%W selection anchor [%W nearest %y]}
    bind .topeditfile.flb.list <ButtonRelease-1> {
	%W selection anchor [%W nearest %y]
	set i [%W curselection]
	if {$i != ""} {
	    global varEditPath ; global entreeEditPath ; global entreeEditFile
	    set entreeEditPath $varEditPath
	    
	    set selection [%W get $i]
	    if {$selection != "../" && [file isfile $entreeEditPath$selection] == 1} {
		set entreeEditFile $selection
		.topeditfile.bOk configure -state normal
		.topeditfile.feFile.f2.e xview [expr [string length $entreeEditFile]-28]
	    } else {
		set entreeEditFile ""
		.topeditfile.bOk configure -state disabled
		.topeditfile.feFile.f2.e xview 0
	    }
	    catch "unset selection"
	}
	catch "unset i"}
    bind .topeditfile.flb.list <Double-Button-1> {
	%W selection anchor [%W nearest %y]
	set i [%W curselection]
	if {$i != ""} {
	    global varEditPath ; global entreeEditPath ; global entreeEditFile
	    set entreeEditPath $varEditPath
	    
	    set selection [%W get $i]
	    if {$selection == "../"} {
		set entreeEditFile ""
		.topeditfile.bOk configure -state disabled
#		set entreeEditPath [AddSlash [file dirname [file dirname $entreeEditPath]]]
		set entreeEditPath [AddSlash [file dirname $entreeEditPath]]
		LsToListbox $entreeEditPath "*" .topeditfile.flb.list
		.topeditfile.fePath.f2.e xview [expr [string length $entreeEditPath]-28]
	    } else {
		if {[file isfile $entreeEditPath$selection] == 1} {
		    set entreeEditFile $selection
		    .topeditfile.bOk configure -state normal
		    .topeditfile.bOk flash
		    .topeditfile.bOk invoke
		} else {
		    # $selection est un repertoire
		    set entreeEditFile ""
		    .topeditfile.bOk configure -state disabled
		    set entreeEditPath $entreeEditPath$selection
		    LsToListbox $entreeEditPath "*" .topeditfile.flb.list
		    .topeditfile.fePath.f2.e xview [expr [string length $entreeEditPath]-28]
		}
	    }
	    catch "unset selection"
	    set varEditPath $entreeEditPath
	}
	catch "unset i"}

    # build widget .topeditfile.lbl
    label .topeditfile.lbl \
	-font $font1 \
	-bg {grey80} \
	-relief {raised} \
	-text {Select a file to edit}
    
    # pack widget .topeditfile
    pack append .topeditfile \
	.topeditfile.lbl {top frame center fill} \
	.topeditfile.flb {top frame center expand fill} \
	.topeditfile.fePath {top frame center fill} \
	.topeditfile.feFile {top frame center fill} \
	.topeditfile.bCancel {left frame center expand fill} \
	.topeditfile.bOk {left frame center expand fill} 
    
    if {"[info procs XFEdit]" != ""} {
	catch "XFMiscBindWidgetTree .topeditfile"
	after 2 "catch {XFEditSetShowWindows}"
    }
}
