##############################################################################
# Construction de la fenetre .tophelp
##############################################################################

# procedure to show window ShowWindow.tophelp
proc ShowWindow.tophelp { args} {
    # xf ignore me 7
    
    # build widget .tophelp
    if {"[info procs XFEdit]" != ""} {
	catch "XFDestroy .tophelp"
    } {
	catch "destroy .tophelp"
    }
    toplevel .tophelp 
    
    # Window manager configurations
    wm positionfrom .tophelp ""
    wm sizefrom .tophelp ""
    wm minsize .tophelp 10 10
    wm title .tophelp {daTac: Help}

    global font1
    
    # build widget .tophelp.bOk
    button .tophelp.bOk \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {DestroyWindow .tophelp} \
	-cursor {hand1} \
	-text {Ok}
    
    # build widget .tophelp.feTitle
    frame .tophelp.feTitle \
	-relief {raised}
    
    # build widget .tophelp.feTitle.e
    entry .tophelp.feTitle.e \
	-font $font1 \
	-bg {grey80} \
	-cursor {top_left_arrow} \
	-relief {sunken} \
	-state {disabled} \
	-textvariable {entreeTitle}
    
    # build widget .tophelp.feTitle.lbl
    label .tophelp.feTitle.lbl \
	-font $font1 \
	-bg {grey80} \
	-padx {2} \
	-relief {flat} \
	-text {Title:}
    
    # pack widget .tophelp.feTitle
    pack append .tophelp.feTitle \
	.tophelp.feTitle.lbl {left frame center} \
	.tophelp.feTitle.e {top frame center expand fill} 
    
    # build widget .tophelp.feTopic
    frame .tophelp.feTopic \
	-relief {raised}
    
    # build widget .tophelp.feTopic.e
    entry .tophelp.feTopic.e \
	-font $font1 \
	-bg {grey80} \
	-cursor {top_left_arrow} \
	-relief {sunken} \
	-state {disabled} \
	-textvariable {entreeTopic}
    
    # build widget .tophelp.feTopic.lbl
    label .tophelp.feTopic.lbl \
	-font $font1 \
	-bg {grey80} \
	-padx {2} \
	-relief {flat} \
	-text {Topic:}
    
    # pack widget .tophelp.feTopic
    pack append .tophelp.feTopic \
	.tophelp.feTopic.lbl {left frame center} \
	.tophelp.feTopic.e {top frame center expand fill} 
    
    # build widget .tophelp.flb
    frame .tophelp.flb

    ScrolledListbox2 .tophelp.flb -width 20 -height 6

    # bindings
    bind .tophelp.flb.list <B1-Motion> {%W selection anchor [%W nearest %y]}
    bind .tophelp.flb.list <Button-1> {%W selection anchor [%W nearest %y]}
    bind .tophelp.flb.list <ButtonRelease-1> {
	%W selection anchor [%W nearest %y]
	set i [%W curselection]
	if {$i != ""} {
	    set selection [%W get $i]
	    if {$selection == "../"} {
		#                      $selection vaut "../"
		set entreeTopic ""
		set entreeTitle ""
	    } else {
		global selectPatternHelp
		set extensionHelp [file extension $selectPatternHelp]
		set entreeTopic $selection
		
		set fich $varHelpPath$selection$extensionHelp
		if {[file isfile $fich] == 1} {
		    #                      $selection est un fichier
		    if {[file readable $fich] == 1} {
			set f [open $fich r]
			set entreeTitle [gets $f]
			close $f
		    } else {
			set entreeTitle ""
		    }
		} else {
		    #                      $selection est un repertoire
		    global extensionDirHelp
		    set fich "$varHelpPath$selection$extensionDirHelp"
		    if {[file exists $fich] == 1 && [file readable $fich] == 1} {
			set f [open $fich r]
			set entreeTitle [gets $f]
			close $f
		    } else {
			set entreeTitle ""
		    }
		}
		catch "unset extensionHelp" ; catch "unset f" ; catch "unset fich"
	    }
	    catch "unset selection"
	}
	catch "unset i"}
    bind .tophelp.flb.list <Double-Button-1> {
	%W selection anchor [%W nearest %y]
	set i [%W curselection]
	if {$i != ""} {
	    global selectPatternHelp
	    set extensionHelp [file extension $selectPatternHelp]
	    set selection [%W get $i]
	    
	    if {$selection == "../"} {
		
		########## 1er cas ##########################
		## On remonte d'un niveau dans l'arborescence
		#############################################
		
		set entreeChemTopic [AddSlash [file dirname $entreeChemTopic]]
		.tophelp.lbl configure -text "Topics in: $entreeChemTopic"
		
		.tophelp.ftext.text delete 1.0 end
		#.tophelp.flb.list delete 0 end
		set varHelpPath "[file dirname $varHelpPath]/"
		LsHelp $varHelpPath $selectPatternHelp .tophelp.flb.list
		
		global pathHelp
		if {$varHelpPath == $pathHelp} {
		    set entreeTopic ""
		    set entreeTitle ""
		} else {
		    set entreeTopic [file tail [file dirname $varHelpPath]]
		    set fich $varHelpPath$entreeTopic$extensionDirHelp
		    if {[file exists $fich] == 1 && [file readable $fich] == 1} {
			set f [open $fich r]
			set entreeTitle [gets $f]
			close $f
		    } else {
			set entreeTitle ""
		    }
		}
		## Fin du 1er cas ###########################
		
	    } else {
		set fich $varHelpPath$selection$extensionHelp
		if {[file isfile $fich] == 1} {
		    
		    ########## 2e cas ###################
		    ## $selection correspond a un fichier
		    ## On lit un fichier d'aide
		    #####################################
		    
		    set entreeTopic $selection
		    .tophelp.ftext.text delete 1.0 end
		    
		    if {[file readable $fich] == 1} {
			set f [open "$varHelpPath$selection$extensionHelp"]
			set entreeTitle [gets $f]
			close $f
			FileToText "$varHelpPath$selection$extensionHelp" .tophelp.ftext.text
		    } else {
			set entreeTitle ""
			ShowWindow.topmessage
			.topmessage.msg configure -text "\n\nHelp:\n\nCan't read file\n\n\"$fich\".\n\nPermission denied.\n\n"
		    }
		    ## Fin du 2e cas ####################
		    
		} else {
		    
		    ########## 3e cas ######################
		    ## $selection correspond a un repertoire
		    ## On avance dans l'arborescence
		    ########################################
		    
		    set entreeChemTopic "$entreeChemTopic$selection"
		    .tophelp.lbl configure -text "Topics in: $entreeChemTopic"
		    
		    .tophelp.ftext.text delete 1.0 end
		    #.tophelp.flb.list delete 0 end
		    set varHelpPath "$varHelpPath$selection"
		    LsHelp $varHelpPath $selectPatternHelp .tophelp.flb.list
		    
		    global extensionDirHelp
		    set entreeTopic [file dirname $selection]
		    
		    set fich $varHelpPath$entreeTopic$extensionDirHelp
		    if {[file exists $fich] == 1 && [file readable $fich] == 1} {
			set f [open $fich r]
			set entreeTitle [gets $f]
			close $f
		    } else {
			set entreeTitle ""
		    }
		    ## Fin du 3e cas #######################
		    
		}
	    }
	    catch "unset selection" ; catch "unset extensionHelp"
	    catch "unset fich" ; catch "unset f"
	}
	catch "unset i"}
    

    # build widget .tophelp.ftext
    frame .tophelp.ftext -relief {raised}
    
    # build widget .tophelp.ftext.sy
    scrollbar .tophelp.ftext.sy \
	-command {.tophelp.ftext.text yview} \
	-relief {raised} \
	-width {11}
    
    # build widget .tophelp.ftext.text
    text .tophelp.ftext.text \
	-font $font1 \
	-borderwidth {2} \
	-height {18} \
	-relief {raised} \
	-width {70} \
	-wrap {word} \
	-yscrollcommand {.tophelp.ftext.sy set}
    
    # bindings
    bind .tophelp.ftext.text <Any-Key> {NoFunction}
    
    # pack widget .tophelp.ftext
    pack append .tophelp.ftext \
	.tophelp.ftext.sy {left frame center filly} \
	.tophelp.ftext.text {top frame center expand fill} 
    
    # build widget .tophelp.lbl
    label .tophelp.lbl \
	-font $font1 \
	-bg {grey80} \
	-relief {raised} \
	-text {Topics in: /}
    
    # pack widget .tophelp
    pack append .tophelp \
	.tophelp.lbl {top frame center fillx} \
	.tophelp.flb {top frame center fillx} \
	.tophelp.feTopic {top frame center fillx} \
	.tophelp.feTitle {top frame center fillx} \
	.tophelp.bOk {bottom frame center fillx}  \
	.tophelp.ftext {bottom frame center expand fill}
    
    
    if {"[info procs XFEdit]" != ""} {
	catch "XFMiscBindWidgetTree .tophelp"
	after 2 "catch {XFEditSetShowWindows}"
    }
}
