##############################################################################
# Construction de la fenetre .toploadfile
##############################################################################

# procedure to show window ShowWindow.toploadfile
proc ShowWindow.toploadfile { args} {
    # xf ignore me 7
    
    # build widget .toploadfile
    if {"[info procs XFEdit]" != ""} {
	catch "XFDestroy .toploadfile"
    } {
	catch "destroy .toploadfile"
    }
    toplevel .toploadfile 
    
    # Window manager configurations
    wm positionfrom .toploadfile ""
    wm sizefrom .toploadfile ""
    wm minsize .toploadfile 10 10
    wm title .toploadfile {daTac: Load Example}

    global {font1}
    
    # bindings
    bind .toploadfile <Enter> {focus .toploadfile.fePath.f2.e}
    
    # build widget .toploadfile.bCancel
    button .toploadfile.bCancel \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {DestroyWindow .toploadfile} \
	-cursor {circle} \
	-text {Cancel}
    
    # build widget .toploadfile.bOk
    button .toploadfile.bOk \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    if {$entreeLoadFile != "" && $entreeLoadPath != ""} {
		.toploadfile.bOk configure -state disabled
		.toploadfile.bCancel configure -state disabled
		set entreeLoadPath [AddSlash $entreeLoadPath]
		
		# Verifier que le fichier $entreeLoadFile existe
		if {[file exists $entreeLoadPath$entreeLoadFile] == 0} {
		    ShowWindow.topmessage
		    .topmessage.msg configure -text "\n\nFile: Edit\n\nCan't find file\n\n\"$entreeLoadPath$entreeLoadFile\".\n\nNo such file or directory.\n\n"
		} else {
		    
		    # Lecture du fichier de donnees
		    .menubar.mbexecution.m entryconfigure 0 -state disabled
		    .menubar.mbexecution.m entryconfigure 1 -state disabled
		    if {[LoadDataFromFile "$entreeLoadPath$entreeLoadFile"] == 1} {
			set varFilename $entreeLoadFile
			set varPathname $entreeLoadPath
			DestroyWindow .toploadfile
		    }
		    .menubar.mbexecution.m entryconfigure 0 -state normal
		    .menubar.mbexecution.m entryconfigure 1 -state normal
		}
	    }
	} \
	-cursor {hand1} \
	-state {disabled} \
	-text {Ok}
    
    # build widget .toploadfile.feFile
    frame .toploadfile.feFile \
	-borderwidth {2} \
	-relief {raised}
    
    ScrolledEntry .toploadfile.feFile {Filename:} entreeLoadFile
    .toploadfile.feFile.f2.e configure -state {disabled}
    
    # build widget .toploadfile.fePath
    frame .toploadfile.fePath \
	-borderwidth {2} \
	-relief {raised}
    
    ScrolledEntry .toploadfile.fePath {Pathname:} entreeLoadPath -width {30}

    # bindings
    bind .toploadfile.fePath.f2.e <Key-Return> {
	global entreeLoadPath ; global entreeLoadFile
	global varLoadPath
	set entreeLoadFile ""
	set entreeLoadPath [string trim $entreeLoadPath]
	if {$entreeLoadPath == ""} {
	    set entreeLoadPath $varLoadPath
	} else {
	    set entreeLoadPath [SearchDirectory [AddSlash $entreeLoadPath]]
	    if {$entreeLoadPath == ""} {
		set entreeLoadPath $varLoadPath
	    } else {
		set varLoadPath $entreeLoadPath
	    }
	}
	global selectPatternData
	LsToListbox  $entreeLoadPath $selectPatternData .toploadfile.flb.list
	.toploadfile.fePath.f2.e xview [expr [string length $entreeLoadPath]-28]
    }
    
    # build widget .toploadfile.flb
    frame .toploadfile.flb
    
    ScrolledListbox2 .toploadfile.flb
    
    # bindings
    bind .toploadfile.flb.list <B1-Motion> {%W selection anchor [%W nearest %y]}
    bind .toploadfile.flb.list <Button-1> {%W selection anchor [%W nearest %y]}
    bind .toploadfile.flb.list <ButtonRelease-1> {
	%W selection anchor [%W nearest %y]
	set i [%W curselection]
	if {$i != ""} {
	    global varLoadPath ; global entreeLoadPath ; global entreeLoadFile
	    set entreeLoadPath $varLoadPath
	    
	    set selection [%W get $i]
	    if {$selection != "../" && [file isfile $entreeLoadPath$selection] == 1} {
		set entreeLoadFile $selection
		.toploadfile.bOk configure -state normal
		.toploadfile.feFile.f2.e xview [expr [string length $entreeLoadFile]-28]
	    } else {
		set entreeLoadFile ""
		.toploadfile.bOk configure -state disabled
		.toploadfile.feFile.f2.e xview 0
	    }
	    catch "unset selection"
	}
	catch "unset i"}
    bind .toploadfile.flb.list <Double-Button-1> {
	%W selection anchor [%W nearest %y]
	set i [%W curselection]
	if {$i != ""} {
	    global varLoadPath ; global entreeLoadPath ; global entreeLoadFile
	    set entreeLoadPath $varLoadPath
	    
	    global selectPatternData
	    set selection [%W get $i]
	    if {$selection == "../"} {
		set entreeLoadFile ""
		.toploadfile.bOk configure -state disabled
#		set entreeLoadPath [AddSlash [file dirname [file dirname $entreeLoadPath]]]
		set entreeLoadPath [AddSlash [file dirname $entreeLoadPath]]
		LsToListbox $entreeLoadPath $selectPatternData .toploadfile.flb.list
		.toploadfile.fePath.f2.e xview [expr [string length $entreeLoadPath]-28]
	    } else {
		if {[file isfile $entreeLoadPath$selection] == 1} {
		    set entreeLoadFile $selection
		    .toploadfile.bOk configure -state normal
		    .toploadfile.bOk flash
		    .toploadfile.bOk invoke
		} else { # $selection est un repertoire
		    set entreeLoadFile ""
		    .toploadfile.bOk configure -state disabled
		    set entreeLoadPath $entreeLoadPath$selection
		    LsToListbox $entreeLoadPath $selectPatternData .toploadfile.flb.list
		    .toploadfile.fePath.f2.e xview [expr [string length $entreeLoadPath]-28]
		}
	    }
	    catch "unset selection"
	    set varLoadPath $entreeLoadPath
	}
	catch "unset i"}
    
    # build widget .toploadfile.lbl
    label .toploadfile.lbl \
	-font $font1 \
	-bg {grey80} \
	-relief {raised} \
	-text {Select a file to load}
    
    # pack widget .toploadfile
    pack append .toploadfile \
	.toploadfile.lbl {top frame center fill} \
	.toploadfile.flb {top frame center expand fill} \
	.toploadfile.fePath {top frame center fill} \
	.toploadfile.feFile {top frame center fill} \
	.toploadfile.bCancel {left frame center expand fill} \
	.toploadfile.bOk {left frame center expand fill} 
    
    if {"[info procs XFEdit]" != ""} {
	catch "XFMiscBindWidgetTree .toploadfile"
	after 2 "catch {XFEditSetShowWindows}"
    }
}
