##############################################################################
# Construction de la fenetre .topoperators
##############################################################################

# procedure to show window ShowWindow.topoperators
proc ShowWindow.topoperators { args } {
    # xf ignore me 7
    
    # build widget .topoperators
    if {"[info procs XFEdit]" != ""} {
	catch "XFDestroy .topoperators"
    } {
	catch "destroy .topoperators"
    }
    toplevel .topoperators -relief {raised}
    
    # Window manager configurations
    wm title .topoperators {daTac: Operators}

    global {font1}
    
    # bindings
    bind .topoperators <Enter> {
	focus .topoperators.fop.frame.f2.e
	if {[.topoperators.flb.flbop.lb curselection] == ""} {
	    .topoperators.fminop.bStore configure -state disabled
	    .topoperators.fl.fbstatus.mb configure -state disabled
	    .topoperators.fl.fbAC_C.mb configure -state disabled
	}
    }
    
    # build widget .topoperators.fb
    frame .topoperators.fb \
	-borderwidth {2} \
	-relief {raised}
    
    # build widget .topoperators.fb.bCancel
    button .topoperators.fb.bCancel \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {DestroyWindow .topoperators} \
	-cursor {circle} \
	-text {Cancel}
    
    # build widget .topoperators.fb.bHelp
    button .topoperators.fb.bHelp \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    global entreeTopic
	    set entreeTopic "2. Operators"
	    LoadHelp "2. Data Menu/2. Operators.hlp"
	} \
	-cursor {question_arrow} \
	-text {Help}
    
    # build widget .topoperators.fb.bStore
    button .topoperators.fb.bStore \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    set dictionnaire [SaveOperators]
	    set varMinOp $entreeMinOp
	    ChangeButtonState .topoperators.fb.b disabled Store
	} \
	-cursor {plus} \
 	-state {disabled} \
	-text {Store}
   
    # build widget .topoperators.fb.bOk
    button .topoperators.fb.bOk \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    set dictionnaire [SaveOperators]
	    set varMinOp $entreeMinOp
	    DestroyWindow .topoperators
	} \
	-cursor {hand1} \
	-text {Ok}
    
    # build widget .topoperators.fb.bReset
    button .topoperators.fb.bReset \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    .topoperators.flb.flbop.lb delete 0 end
	    .topoperators.flb.flbAC_C.lb delete 0 end
	    .topoperators.flb.flbstatus.lb delete 0 end
	    .topoperators.flb.flbinfop.lb delete 0 end
	    .topoperators.flb.flbeqop.lb delete 0 end
	    global defaultDictionnaire
	    set dico $defaultDictionnaire
	    DisplayOperators $dico
	    catch "unset dico"
	    set entreeMinOp ""
	    set entreeOperators ""
	    set entreePrecedence ""
	    .topoperators.fl.fbstatus.mb configure -state disabled
	    .topoperators.fl.fbAC_C.mb configure -state disabled
	    ChangeButtonState .topoperators.fminop.b disabled [list Store Clear]
	    ChangeButtonState .topoperators.fprec.b disabled [list Inf Eq Store Clear]
	    ChangeButtonState .topoperators.fb.b active Store
	} \
	-cursor {pirate} \
	-text {Reset}
    
    # pack widget .topoperators.fb
    pack append .topoperators.fb \
	.topoperators.fb.bHelp {left frame center expand fill} \
	.topoperators.fb.bReset {left frame center expand fill} \
	.topoperators.fb.bCancel {left frame center expand fill} \
	.topoperators.fb.bStore {left frame center expand fill} \
	.topoperators.fb.bOk {left frame center expand fill}
    
    
    # build widget .topoperators.fl
    frame .topoperators.fl \
	-borderwidth {2} \
	-relief {raised}
    

    # build widget .topoperators.flb
    frame .topoperators.flb \
	-borderwidth {2} \
	-relief {raised}
        
    # build widget .topoperators.flb.flbop
    frame .topoperators.flb.flbop
    
    # build widget .topoperators.flb.flbop.sx
    scrollbar .topoperators.flb.flbop.sx \
	-command {.topoperators.flb.flbop.lb xview} \
	-orient {horizontal} \
	-width 11
    
    # build widget .topoperators.flb.flbop.lbl
    label .topoperators.fl.lblop \
	-font $font1 \
	-pady {3} \
	-bg {grey80} \
	-borderwidth {2} \
	-relief {raised} \
	-text {Operators} \
	-width 13
    
    frame .topoperators.flb.flbop.pad
    frame .topoperators.flb.flbop.pad.it -width 11 -height 11

    # build widget .topoperators.flb.flbop.pad.sy
    scrollbar .topoperators.flb.flbop.pad.sy \
	-command {MultiListboxesScrollbar} \
	-width 11
    
    # build widget .topoperators.flb.flbop.lb
    listbox .topoperators.flb.flbop.lb \
	-font $font1 \
	-relief {sunken} \
	-cursor {hand2} \
	-width 11 -height 8 \
	-xscrollcommand {.topoperators.flb.flbop.sx set} \
	-yscrollcommand {.topoperators.flb.flbop.pad.sy set} -setgrid 1
    
    # bindings
    bind .topoperators.flb.flbop.lb <B1-Motion> {applyB1Motion [%W nearest %y]}
    bind .topoperators.flb.flbop.lb <ButtonRelease-1> {applyB1Release [%W nearest %y]}
    bind .topoperators.flb.flbop.lb <Double-ButtonRelease-1> {applyDblB1Release [%W nearest %y]}
    
    # pack widget .topoperators.flb.flbop
    pack append .topoperators.flb.flbop.pad \
	.topoperators.flb.flbop.pad.it {bottom frame center fill} \
	.topoperators.flb.flbop.pad.sy {left frame center fill}
    pack append .topoperators.flb.flbop \
	.topoperators.flb.flbop.pad {left frame center filly} \
	.topoperators.flb.flbop.sx {bottom frame center fillx} \
	.topoperators.flb.flbop.lb {right frame center expand fill}
    

    # build widget .topoperators.flb.flbAC_C
    frame .topoperators.flb.flbAC_C 
    
    # build widget .topoperators.flb.flbAC_C.sx
    scrollbar .topoperators.flb.flbAC_C.sx \
	-command {.topoperators.flb.flbAC_C.lb xview} \
	-orient {horizontal} \
	-width 11
    
    # build widget .topoperators.flb.flbAC_C.fb
    frame .topoperators.fl.fbAC_C \
	-borderwidth {2} \
	-bg {grey80} \
	-relief {raised} \
	-width 11
    
    # build widget .topoperators.flb.flbAC_C.fb.lbl
    label .topoperators.fl.fbAC_C.lbl \
	-font $font1 \
	-bg {grey80} \
	-relief {flat} \
	-text {Property}

    # build widget .topoperators.flb.flbAC_C.fb.mb
    menubutton .topoperators.fl.fbAC_C.mb \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-cursor {hand2} \
	-state {disabled} \
	-menu {.topoperators.fl.fbAC_C.mb.m} \
	-relief {raised} \
	-text {v}

    # build widget .topoperators.flb.flbAC_C.fb.mb.m
    menu .topoperators.fl.fbAC_C.mb.m -tearoff "false"
    .topoperators.fl.fbAC_C.mb.m add command \
	-font $font1 \
	-command {Change_AC_C AC} \
	-label {AC}
    .topoperators.fl.fbAC_C.mb.m add command \
	-font $font1 \
	-command {Change_AC_C C} \
	-label {C}
    .topoperators.fl.fbAC_C.mb.m add command \
	-font $font1 \
	-command {Change_AC_C Normal} \
	-label {Normal}
    
    # pack widget .topoperators.flb.flbAC_C.fb
    pack append .topoperators.fl.fbAC_C \
	.topoperators.fl.fbAC_C.mb {right frame center} \
	.topoperators.fl.fbAC_C.lbl {top frame center expand fillx}
    
    # build widget .topoperators.flb.flbAC_C.lb
    listbox .topoperators.flb.flbAC_C.lb \
	-font $font1 \
	-width 11 -height 5 \
	-relief {ridge} \
	-selectbackground {white} \
	-selectforeground {black} \
	-xscrollcommand {.topoperators.flb.flbAC_C.sx set} \
	-yscrollcommand {.topoperators.flb.flbop.pad.sy set}
    
    # bindings
    bind .topoperators.flb.flbAC_C.lb <B1-Motion> {applyB1Motion [%W nearest %y]}
    bind .topoperators.flb.flbAC_C.lb <ButtonRelease-1> {applyB1Release [%W nearest %y]}
    bind .topoperators.flb.flbAC_C.lb <Double-ButtonRelease-1> {applyDblB1Release [%W nearest %y]}
    
    # pack widget .topoperators.flb.flbAC_C
    pack append .topoperators.flb.flbAC_C \
	.topoperators.flb.flbAC_C.sx {bottom frame center fillx} \
	.topoperators.flb.flbAC_C.lb {top frame center expand fill}
    

    # build widget .topoperators.flb.flbstatus
    frame .topoperators.flb.flbstatus 
    
    # build widget .topoperators.flb.flbstatus.sx
    scrollbar .topoperators.flb.flbstatus.sx \
	-command {.topoperators.flb.flbstatus.lb xview} \
	-orient {horizontal} \
	-width 11
    
    # build widget .topoperators.flb.flbstatus.fb
    frame .topoperators.fl.fbstatus \
	-borderwidth {2} \
	-bg {grey80} \
	-relief {raised} \
	-width 8
    
    # build widget .topoperators.fl.flstatus.fb.lbl
    label .topoperators.fl.fbstatus.lbl \
	-font $font1 \
	-bg {grey80} \
	-relief {flat} \
	-text {Status}
    
    # build widget .topoperators.fl.flstatus.fb.mb
    menubutton .topoperators.fl.fbstatus.mb \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-cursor {hand2} \
	-state {disabled} \
	-menu {.topoperators.fl.fbstatus.mb.m} \
	-relief {raised} \
	-text {v}
    
    # build widget .topoperators.fl.flstatus.fb.mb.m
    menu .topoperators.fl.fbstatus.mb.m -tearoff "false"
    .topoperators.fl.fbstatus.mb.m add command \
	-font $font1 \
	-command {ChangeStatus LexicoLR} \
	-label {LexicoLR}
    .topoperators.fl.fbstatus.mb.m add command \
	-font $font1 \
	-command {ChangeStatus LexicoRL} \
	-label {LexicoRL}
    .topoperators.fl.fbstatus.mb.m add command \
	-font $font1 \
	-command {ChangeStatus Multiset} \
	-label {Multiset}
    
    # pack widget .topoperators.flb.flbstatus.fb
    pack append .topoperators.fl.fbstatus \
	.topoperators.fl.fbstatus.mb {right frame center} \
	.topoperators.fl.fbstatus.lbl {top frame center expand fillx}
    
    # build widget .topoperators.flb.flbstatus.lb
    listbox .topoperators.flb.flbstatus.lb \
	-font $font1 \
	-relief {ridge} \
	-selectbackground {white} \
	-selectforeground {black} \
	-width 9 -height 5 \
	-xscrollcommand {.topoperators.flb.flbstatus.sx set} \
	-yscrollcommand {.topoperators.flb.flbop.pad.sy set}

    # bindings
    bind .topoperators.flb.flbstatus.lb <B1-Motion> {applyB1Motion [%W nearest %y]}
    bind .topoperators.flb.flbstatus.lb <ButtonRelease-1> {applyB1Release [%W nearest %y]}
    bind .topoperators.flb.flbstatus.lb <Double-ButtonRelease-1> {applyDblB1Release [%W nearest %y]}
    
    # pack widget .topoperators.flb.flbstatus
    pack append .topoperators.flb.flbstatus \
	.topoperators.flb.flbstatus.sx {bottom frame center fillx} \
	.topoperators.flb.flbstatus.lb {top frame center expand fill}
    

    # build widget .topoperators.flb.flbinfop
    frame .topoperators.flb.flbinfop 
    
    # build widget .topoperators.flb.flbinfop.sx
    scrollbar .topoperators.flb.flbinfop.sx \
	-command {.topoperators.flb.flbinfop.lb xview} \
	-orient {horizontal} \
	-width 11
    
    # build widget .topoperators.flb.flbinfop.lbl
    label .topoperators.fl.lblinfop \
	-font $font1 \
	-pady {3} \
	-bg {grey80} \
	-borderwidth {2} \
	-relief {raised} \
	-text {Greater than} \
	-width 11
    
    # build widget .topoperators.flb.flbinfop.lb
    listbox .topoperators.flb.flbinfop.lb \
	-font $font1 \
	-width 11 -height 5 \
	-relief {ridge} \
	-selectbackground {white} \
	-selectforeground {black} \
	-xscrollcommand {.topoperators.flb.flbinfop.sx set} \
	-yscrollcommand {.topoperators.flb.flbop.pad.sy set} -setgrid 1
    
    # bindings
    bind .topoperators.flb.flbinfop.lb <B1-Motion> {applyB1Motion [%W nearest %y]}
    bind .topoperators.flb.flbinfop.lb <ButtonRelease-1> {applyB1Release [%W nearest %y]}
    bind .topoperators.flb.flbinfop.lb <Double-ButtonRelease-1> {applyDblB1Release [%W nearest %y]}
    
    # pack widget .topoperators.flb.flbinfop
    pack append .topoperators.flb.flbinfop \
	.topoperators.flb.flbinfop.sx {bottom frame center fillx} \
	.topoperators.flb.flbinfop.lb {top frame center expand fill} 
    

    # build widget .topoperators.flb.flbeqop
    frame .topoperators.flb.flbeqop 
    
    # build widget .topoperators.flb.flbeqop.sx
    scrollbar .topoperators.flb.flbeqop.sx \
	-command {.topoperators.flb.flbeqop.lb xview} \
	-orient {horizontal} \
	-width 11
    
    # build widget .topoperators.flb.flbeqop.lbl
    label .topoperators.fl.lbleqop \
	-font $font1 \
	-pady {3} \
	-bg {grey80} \
	-borderwidth {2} \
	-relief {raised} \
	-text {Equal to} \
	-width 11
    
    # build widget .topoperators.flb.flbeqop.lb
    listbox .topoperators.flb.flbeqop.lb \
	-font $font1 \
	-width 11 -height 5 \
	-relief {ridge} \
	-selectbackground {white} \
	-selectforeground {black} \
	-xscrollcommand {.topoperators.flb.flbeqop.sx set} \
	-yscrollcommand {.topoperators.flb.flbop.pad.sy set} -setgrid 1
    
    # bindings
    bind .topoperators.flb.flbeqop.lb <B1-Motion> {applyB1Motion [%W nearest %y]}
    bind .topoperators.flb.flbeqop.lb <ButtonRelease-1> {applyB1Release [%W nearest %y]}
    bind .topoperators.flb.flbeqop.lb <Double-ButtonRelease-1> {applyDblB1Release [%W nearest %y]}
    
    # pack widget .topoperators.flb.flbeqop
    pack append .topoperators.flb.flbeqop \
	.topoperators.flb.flbeqop.sx {bottom frame center fillx} \
	.topoperators.flb.flbeqop.lb {top frame center expand fill} 
    
    # pack widget .topoperators.flb
    pack append .topoperators.flb \
	.topoperators.flb.flbop {left frame center expand fill} \
	.topoperators.flb.flbAC_C {left frame center fill} \
	.topoperators.flb.flbstatus {left frame center fill} \
	.topoperators.flb.flbinfop {left frame center expand fill} \
	.topoperators.flb.flbeqop {left frame center expand fill} 

    # pack widget .topoperators.fl
    pack append .topoperators.fl \
	.topoperators.fl.lblop {left frame center expand fill} \
	.topoperators.fl.fbAC_C {left frame center fill} \
	.topoperators.fl.fbstatus {left frame center fill} \
	.topoperators.fl.lblinfop {left frame center expand fill} \
	.topoperators.fl.lbleqop {left frame center expand fill} 

    
    # build widget .topoperators.fminop
    frame .topoperators.fminop \
	-borderwidth {2} \
	-relief {raised}
    
    # build widget .topoperators.fminop.bStore
    button .topoperators.fminop.bStore \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    set i [.topoperators.flb.flbop.lb curselection]
	    if {$i != ""} {
		set newminop [.topoperators.flb.flbop.lb get $i]
		if {[IsMinimalOp $i] == 1} {
		    set entreeMinOp $newminop
		    ChangeButtonState .topoperators.fb.b active Store
		    ChangeButtonState .topoperators.fminop.b active Clear
		    ChangeButtonState .topoperators.fminop.b disabled Store
		} else {
		    ShowWindow.topmessage
		    .topmessage.msg configure -text "\n\nMinimal Operator:\n\nOperator \"$newminop\" cannot be minimal\n\nInsertion aborted\n\n"
		}
		catch "unset newminop"
	    }
	    catch "unset i"
	} \
	-state {disabled} \
	-cursor {plus} \
	-text {Store}
    
    # build widget .topoperators.fminop.bClear
    button .topoperators.fminop.bClear \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    set entreeMinOp ""
	    ChangeButtonState .topoperators.fb.b active Store
	    ChangeButtonState .topoperators.fminop.b disabled Clear
	} \
	-cursor {circle} \
	-text {Clear}
    
    # build widget .topoperators.fminop.frame
    frame .topoperators.fminop.frame 
    
    ScrolledEntry .topoperators.fminop.frame {Minimal Op.:} entreeMinOp \
	-cursor {top_left_arrow} -state {disabled} -width {5}

    # pack widget .topoperators.fminop
    pack append .topoperators.fminop \
	.topoperators.fminop.bClear {right frame center filly} \
	.topoperators.fminop.bStore {right frame center filly} \
	.topoperators.fminop.frame {left frame center expand fillx} 
    

    # build widget .topoperators.fop
    frame .topoperators.fop \
	-borderwidth {2} \
	-relief {raised}
    
    # build widget .topoperators.fop.bAdd
    button .topoperators.fop.bAdd \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    set listNewOp [split [string trim $entreeOperators] " "]
	    set listBadOp {}
	    foreach elem $listNewOp {
		if {$elem != ""} {
		    if {[CheckOperator $elem] == 1} {
			set ind [IndexListboxInsert $elem .topoperators.flb.flbop.lb]
			if {$ind != -1} {
			    .topoperators.flb.flbop.lb insert $ind $elem
			    .topoperators.flb.flbAC_C.lb insert $ind Normal
			    .topoperators.flb.flbstatus.lb insert $ind LexicoLR
			    .topoperators.flb.flbinfop.lb insert $ind {}
			    .topoperators.flb.flbeqop.lb insert $ind {}
			}
			ChangeButtonState .topoperators.fb.b active Store
		    } else {set listBadOp [concat $listBadOp "`$elem`"]}
		}
	    }
	    if {$listBadOp != ""} {
		ShowWindow.topmessage
		.topmessage.msg configure -text "\n\nAdd Operators:\n\nCan't add operator(s): $listBadOp\n\nBad syntax.\n\n"
	    }
	    set entreeOperators ""
	    catch "unset listNewOp" ; catch "unset listBadOp"
	    catch "unset elem" ; catch "unset ind"
	} \
	-cursor {plus} \
	-text {Add}
    
    # build widget .topoperators.fop.frame
    frame .topoperators.fop.frame
    
    ScrolledEntry .topoperators.fop.frame {New Operators:} entreeOperators

    # bindings
    bind .topoperators.fop.frame.f2.e <Key-Return> {
	.topoperators.fop.bAdd flash
	.topoperators.fop.bAdd invoke
    }
    
    # pack widget .topoperators.fop
    pack append .topoperators.fop \
	.topoperators.fop.bAdd {right frame center filly} \
	.topoperators.fop.frame {left frame center expand fillx} 
    
    
    # build widget .topoperators.fprec
    frame .topoperators.fprec \
	-borderwidth {2} \
	-relief {raised}
    
    # build widget .topoperators.fprec.bClear
    button .topoperators.fprec.bClear \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    set entreePrecedence ""
	    ChangeButtonState .topoperators.fprec.b disabled [list Inf Eq Store Clear]
	} \
	-cursor {circle} \
	-text {Clear}
    
    # build widget .topoperators.fprec.bEq
    button .topoperators.fprec.bEq \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    set entreePrecedence "$entreePrecedence = "
	    ChangeButtonState .topoperators.fprec.b disabled [list Inf Eq Store]
	    .topoperators.fprec.frame.f2.e xview end
	} \
	-cursor {hand2} \
	-state {disabled} \
	-text { = }
    
    # build widget .topoperators.fprec.bInf
    button .topoperators.fprec.bInf \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    set entreePrecedence "$entreePrecedence > "
	    ChangeButtonState .topoperators.fprec.b disabled [list Inf Eq Store]
	    .topoperators.fprec.frame.f2.e xview end
	} \
	-cursor {hand2} \
	-state {disabled} \
	-text { > }
    
    # build widget .topoperators.fprec.bStore
    button .topoperators.fprec.bStore \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    EnterPrecedence [split $entreePrecedence " "] $entreeMinOp
	    set entreePrecedence ""
	    ChangeButtonState .topoperators.fprec.b disabled [list Inf Eq Store Clear]
	    ChangeButtonState .topoperators.fb.b active Store
	} \
	-cursor {plus} \
	-state {disabled} \
	-text {Store}
    
    # build widget .topoperators.fprec.frame
    frame .topoperators.fprec.frame 

    ScrolledEntry .topoperators.fprec.frame {New Precedence:} entreePrecedence \
	-state {disabled} -cursor {top_left_arrow}

    # pack widget .topoperators.fprec
    pack append .topoperators.fprec \
	.topoperators.fprec.bClear {right frame center filly} \
	.topoperators.fprec.bStore {right frame center filly} \
	.topoperators.fprec.bEq {right frame center filly} \
	.topoperators.fprec.bInf {right frame center filly} \
	.topoperators.fprec.frame {left frame center expand fillx} 
    
    frame .topoperators.fpad -width 10 -height [lindex [.topoperators.fop configure -height] 4]

    # pack widget .topoperators
    pack append .topoperators \
	.topoperators.fl {top frame center fill} \
	.topoperators.flb {top frame center expand fill} \
	.topoperators.fb {bottom frame center fillx} \
	.topoperators.fprec {bottom frame center fillx} \
	.topoperators.fminop {right frame center expand fillx} \
	.topoperators.fpad {right frame center} \
	.topoperators.fop {right frame center expand fillx}
    
    if {"[info procs XFEdit]" != ""} {
	catch "XFMiscBindWidgetTree .topoperators"
	after 2 "catch {XFEditSetShowWindows}"
    }
}


# Procedure: applyB1Release
proc applyB1Release { ind } {
    .topoperators.flb.flbop.lb yview $ind
    .topoperators.flb.flbAC_C.lb yview $ind
    .topoperators.flb.flbstatus.lb yview $ind
    .topoperators.flb.flbinfop.lb yview $ind
    .topoperators.flb.flbeqop.lb yview $ind
    .topoperators.flb.flbop.lb selection set $ind
    set i [.topoperators.flb.flbop.lb curselection]
    if {$i != ""} {
	if {[.topoperators.flb.flbop.lb get $i] == "="} {
	    .topoperators.fl.fbAC_C.mb configure -state disabled
	    .topoperators.fminop.bStore configure -state disabled
	} else {
	    .topoperators.fl.fbAC_C.mb configure -state normal
	    .topoperators.fminop.bStore configure -state normal
	}
	if {[.topoperators.flb.flbAC_C.lb get $ind] == "Normal"} {
	    .topoperators.fl.fbstatus.mb configure -state normal
	} else {
	    .topoperators.fl.fbstatus.mb configure -state disabled
	}
    } else {
	.topoperators.fl.fbAC_C.mb configure -state disabled
	.topoperators.fminop.bStore configure -state disabled
    }
    catch "unset i"
}


# Procedure: applyB1Motion
proc applyB1Motion { ind } {
    .topoperators.flb.flbop.lb yview $ind
    .topoperators.flb.flbAC_C.lb yview $ind
    .topoperators.flb.flbstatus.lb yview $ind
    .topoperators.flb.flbinfop.lb yview $ind
    .topoperators.flb.flbeqop.lb yview $ind
    .topoperators.flb.flbop.lb selection set $ind
}


# Procedure: applyDblB1Release
proc applyDblB1Release { ind } {
    if {$ind != ""} {
	set etat [lindex [.topoperators.fprec.bInf configure -state] 4]
	if {$etat == "disabled"} {
	    global entreePrecedence
	    set entreePrecedence "$entreePrecedence[.topoperators.flb.flbop.lb get $ind]"
	    ChangeButtonState .topoperators.fprec.b normal [list Inf Eq]
	    ChangeButtonState .topoperators.fprec.b active Clear
	    if {$entreePrecedence != [.topoperators.flb.flbop.lb get $ind]} {
		.topoperators.fprec.bStore configure -state normal
	    }
	    .topoperators.fprec.frame.f2.e xview end
	}
	catch "unset etat"
    }
    .topoperators.fminop.bStore configure -state disabled
    selection clear .topoperators.flb.flbop.lb
}
